class Quandl::Cassinatra::Base
module Attributes
  
  extend ActiveSupport::Concern
  
  module ClassMethods
  
    def find_existing(id)
      self.new(id: id)
    end
    
  end
  
  def inspect
    "#{self.class.name} " + attributes.inspect
  end
  
  def imprint(record)
    # ensure matching classes
    raise(ArgumentError, "record must be kind_of?(#{self.class})") unless record.kind_of?( self.class )
    # copy variables
    copy_instance_variables(record)
  end
  
  protected
  
  def copy_instance_variables(record)
    # copy attributes if record was found
    @attributes = record.attributes if record.exists?
    # copy metadata and errors
    [:metadata, :response_errors].each do |ivar|
      self.instance_variable_set("@#{ivar}", record.instance_variable_get("@#{ivar}") )
    end
    self
  end
  
  def write_attributes(hash)
    @attributes = hash
  end
  
  def write_attribute(attribute, value)
    self.send(:"#{attribute}_will_change!") if @attributes[:"#{attribute}"] != value
    @attributes[:"#{attribute}"] = value
  end
  
  def read_attribute(attribute)
    @attributes[:"#{attribute}"] 
  end
  
end
end