class Quandl::Cassinatra::Dataset < Quandl::Cassinatra::Base
  
  require 'quandl/cassinatra/models/dataset/searchable'
  require 'quandl/cassinatra/models/dataset/attributes'
  
  include Quandl::Cassinatra::Dataset::Searchable
  include Quandl::Cassinatra::Dataset::Attributes

  def rows_count
    count_data
  end
  
  def count_data
    @count_data ||= self.class.get("datasets/#{id}/count").attributes[:count]
  end

  def delete_data
    # cant delete unsaved records
    return false if new_record?
    # delete and return success / failure
    self.class.destroy_existing("#{id}/data").saved?
  end

  def delete_rows(*dates)
    # cant delete unsaved records
    return false if new_record?
    # collect dates
    query = { dates: Array(dates).flatten }.to_query
    # delete and return success / failure
    self.class.destroy_existing("#{id}/data/rows?#{query}").saved?
  end
  
end